<template>
  <v-card class="d-flex flex-column align-center">
    <span class="text-h4">To Do</span>

    <SortToDo @filterToDo="filter" :filterIsActive="filterIsActive" />

    <TodoList
      :todoList="todolisFilter"
      @toggleTodo="toggleTodo"
      @removeTodo="removeTodo"
    />

    <AddToDo @addToDo="addToDo" />
  </v-card>
</template>

<script setup lang="ts">
import { reactive, ref, computed } from "vue";
import type { TodoItem } from "../types/TodoItems.js";
import TodoList from "./TodoList.vue";
import AddToDo from "./AddToDo.vue";
import SortToDo from "./SortToDo.vue";

let todolist: TodoItem[] = reactive([
  { id: 1, content: "To Do List item", comleted: true },
  { id: 2, content: "Go now", comleted: false },
  { id: 3, content: "Vue", comleted: false },
  { id: 4, content: "TypeScrypt", comleted: false },
]);

let filterIsActive = ref<number>(0);

let filterValue = ref<string>("ALL");

const toggleTodo = (id: number): void => {
  todolist.filter((todo: TodoItem) =>
    todo.id === id ? (todo.comleted = !todo.comleted) : todo
  );
};

const removeTodo = (id: number): void => {
  const index = todolist.findIndex((todo: TodoItem) => todo.id === id);

  todolist.splice(index, 1);
};

const addToDo = (message: string): void => {
  todolist.push({
    id: Date.now(),
    content: message,
    comleted: false,
  });
};

const filter = (filter: string): void => {
  filterValue.value = filter;
};

const todolisFilter = computed(() => {
  switch (filterValue.value) {
    case "ACTIVE":
      filterIsActive.value = 1;
      return todolist.filter((todo: TodoItem) => !todo.comleted);
    case "DONE":
      filterIsActive.value = 2;
      return todolist.filter((todo: TodoItem) => todo.comleted);
    case "ALL":
    default:
      filterIsActive.value = 0;
      return todolist.filter((todo: TodoItem) => todo);
  }
});
</script>
